package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.ModelTestTask;
import com.ruoyi.web.response.ResultCountResponse;
import com.ruoyi.web.response.TaskFindResponse;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 车型试验Mapper层
 * @author gxk
 */
@Repository
public interface ModelTestTaskMapper extends BaseMapper<ModelTestTask> {

    // 查询pending状态下的所有任务
    List<ModelTestTask> findByStatus();

    // 根据总任务列表查询子任务
    List<ModelTestTask> findByTaskList(@Param("responses") List<TaskFindResponse> responses);

    // 根据子任务列表查询进度
    List<ResultCountResponse> testAnswerCount(@Param("responses")List<TaskFindResponse> responses);
}
