package com.ruoyi.service;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.domain.TestUseCase;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.web.request.TestUseCaseByScenarioRequest;
import com.ruoyi.web.request.TestUseCaseIdListRequest;
import com.ruoyi.web.request.TestUserCaseRequest;

import java.util.List;
import java.util.Map;

/**
* @author wangfei
* @description 针对表【t_test_usecase(测试用例)】的数据库操作Service
* @createDate 2024-02-18 13:41:28
*/
public interface TestUseCaseService extends IService<TestUseCase> {
    /**
     * 查询测试用例列表
     *
     * @param testUserCaseRequest 测试用例库
     * @return 测试用例集合
     */
    public List<TestUseCase> selectseCaseList(TestUserCaseRequest testUserCaseRequest);

    /**
     * 通过车型试验ID获取所绑定的测试用例
     * @param request
     * @return
     */
    List<String> selectCaseIdList(TestUseCaseIdListRequest request);

    /**
     * 通过测试场景获取所绑定的测试用例
     * @param request
     * @return
     */
    List<String> selectCaseByScenario(TestUseCaseByScenarioRequest request);

    /**
     * 调用第三方接口
     * @param url
     * @param map
     * @return
     */
    JSONObject callThirdPartyInterface(String url, Map<String, Object> map);
}
