package com.ruoyi.service.impl;


import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.ruoyi.domain.TestType;
import com.ruoyi.mapper.TestTypeMapper;
import com.ruoyi.service.ITestTypeService;

import com.ruoyi.web.request.TestTypeRequest;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.stream.Collectors;

@Service
@Transactional
public class TestTypeServiceImpl extends ServiceImpl<TestTypeMapper, TestType> implements ITestTypeService {

    @Autowired
    private TestTypeMapper testTypeMapper;
    /**
     * 查询测试类型库列表
     *
     * @param testTypeRequest 测试类型库
     * @return 测试类型库
     */
    @Override
    public List<TestType> selectTestTypeList(TestTypeRequest testTypeRequest)
    {
        if(testTypeRequest.getTestType() != null && (testTypeRequest.getTestType().contains("%") ||testTypeRequest.getTestType().contains("_")  )){
            testTypeRequest.setTestType(testTypeRequest.getTestType().toString().replaceAll("%","/%").replaceAll("_","/_"));
        }
        return testTypeMapper.selectTestTypeList(testTypeRequest);
    }

    @Override
    public List<String> getTestTypeList() {
        //以post形式请求接口
        String result= HttpUtil.post("https://10.12.48.78:8090/DescribeScenarioTestTypeList","");
        JSONObject jsonObject = JSONObject.parseObject(result);

        return jsonObject.getList("test_type_list", TypeVO.class)
                .stream()
                .map(TypeVO::getName)
                .collect(Collectors.toList());
    }

    @Data
    public static class TypeVO {

        private String name;

    }
}
