package com.ruoyi.web;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.domain.vo.*;
import com.ruoyi.service.StatisticsHomeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = {"首页统计"})
@RestController
@RequestMapping("/home/statistics")
public class StatisticsHomeController {
    @Autowired
    private StatisticsHomeService statisticsHomeService;

    @ApiOperation("首页数量统计")
    @PostMapping("/quantityStatistics")
    public R<QuantityStatisticsVO> selectQuantityStatistics(@Validated @RequestBody QuantityStatisticsVO quantityStatisticsHome){
        return R.ok(statisticsHomeService.selectQuantityStatistics(quantityStatisticsHome));
    }
    @ApiOperation("首页标准分类占比")
    @PostMapping("/standardCategory")
    public R<List<StandardCategoryStatisticsVO>> selectStandardCategoryStatistics(){
        return R.ok(statisticsHomeService.selectStandardCategoryStatistics());
    }
    @ApiOperation("首页任务保密等级占比")
    @PostMapping("/confidentialityLevel")
    public R<List<ConfidentialityLevelProportionVO>> selectConfidentialityLevelStatistics(){
        return R.ok(statisticsHomeService.selectConfidentialityLevelStatistics());
    }
    @ApiOperation("首页平均检验通过率")
    @PostMapping("/averageInspectionRate")
    public R<List<AverageInspectionRateVO>> selectAverageInspectionRate(){
        return R.ok(statisticsHomeService.selectAverageInspectionRate());
    }
    @ApiOperation("首页任务情况安排")
    @PostMapping("/taskParticipation")
    public R<List<TaskParticipationStatisticsVO>> selectTaskParticipationStatistics(){
        return R.ok(statisticsHomeService.selectTaskParticipationStatistics());
    }
}
