package com.ruoyi.web;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.domain.TestScenario;
import com.ruoyi.service.ITestScenarioService;
import com.ruoyi.web.request.TestScenarioRequest;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.skywalking.apm.toolkit.trace.Tag;
import org.apache.skywalking.apm.toolkit.trace.Tags;
import org.apache.skywalking.apm.toolkit.trace.Trace;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Api(tags = "测试场景")
@RestController
@RequestMapping("/system/scenario")
public class TestScenarioController extends BaseController {


    @Autowired
    private ITestScenarioService testScenarioService;

    /**
     * 测试场景分页
     */
    @ApiOperation("查询测试场景分页查询")
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/getList")
    public TableDataInfo<TestScenario> list(@Validated @RequestBody TestScenarioRequest testScenarioRequest){
        startPage(testScenarioRequest);
        List<TestScenario> list = testScenarioService.selectTestScenarioList(testScenarioRequest);
        return getDataTable(list);
    }

    /**
     * 测试场景列表不分页
     */
    @ApiOperation("查询测试场景")
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/getListAll")
    public R<List<TestScenario>> listAll(@Validated @RequestBody TestScenarioRequest testScenarioRequest){
        return R.ok(testScenarioService.selectTestScenarioList(testScenarioRequest));
    }

    /**
     * 获取测试场景列表(科恩)
     */
    @ApiOperation("查询测试场景(科恩)")
    @PostMapping("/getScenarioList")
    public R<List<String>> getScenarioList(){
        return R.ok(testScenarioService.selectScenarioList());
    }

}
