package com.ruoyi.web.request;

import com.ruoyi.common.core.page.PageDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

/**
 * 检验内容库(标准)分页请求实体类
 * @author gxk
 */
@Data
@ApiModel
public class ReviewStandardListByPageRequest extends PageDomain {

    /**
     * 大标准ID
     */
    @ApiModelProperty("总标准ID")
    @NotNull(message = "总标准ID不能为空")
    private Long standardId;

    /**
     * 标准的类型
     */
    @ApiModelProperty("标准类型[system、car、test]")
    @NotNull(message = "标准类型不能为空")
    @NotEmpty(message = "标准类型不能为空")
    private String type;

    /**
     * 章节
     */
    @ApiModelProperty("章节")
    private String chapter;

    /**
     * 文本内容
     */
    @ApiModelProperty("文本内容")
    private String text;

    @ApiModelProperty("测试方法")
    private String testMethod;
}
