package com.ruoyi.web.response;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@ApiModel(value = "TaskFindPendingResponse", description = "进行中的总任务")
@Data
public class TaskFindResponse {

    @ApiModelProperty("主键")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    @ApiModelProperty("体系审查任务id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long systemReviewTaskId;

    @ApiModelProperty("车辆检查任务id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long carReviewTaskId;

    @ApiModelProperty("车型检验任务id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long modelTestTaskId;

    @ApiModelProperty("下一个子任务")
    private String nextSubTask;


    @ApiModelProperty("标准名称（检验依据）")
    private String name;

    @ApiModelProperty("标准号")
    private String standardNo;

    @ApiModelProperty("任务编号")
    private String taskNo;

    @ApiModelProperty("任务名称")
    private String taskName;

    @ApiModelProperty("车辆型号（产品型号）")
    private String productModel;

    @ApiModelProperty("任务状态（NEW、PENDING、FINISH）")
    private String taskStatus;

    @ApiModelProperty("任务运行状态[RUNNABLE（可运行的）、RUNNING（运行中的）]")
    private String runStatus;

    @ApiModelProperty("总任务开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date taskBeginTime;

    @ApiModelProperty("任务结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date taskEndTime;

    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @ApiModelProperty("审核组长id")
    private Long leaderId;

    @ApiModelProperty("审核组长姓名")
    private String leader;

    @ApiModelProperty("体系审查任务状态")
    private String reviewStatus;

    @ApiModelProperty("体系审查任务进度")
    private Double systemReview;

    @ApiModelProperty("体系问卷任务开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date systemTaskBeginTime;

    @ApiModelProperty("体系问卷任务结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date systemTaskEndTime;

    @ApiModelProperty("车型审查任务状态")
    private String carReviewStatus;

    @ApiModelProperty("车型审查任务进度")
    private Double carReview;

    @ApiModelProperty("车辆问卷任务开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date carTaskBeginTime;

    @ApiModelProperty("车辆问卷任务结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date carTaskEndTime;

    @ApiModelProperty("测试任务状态")
    private String testStatus;

    @ApiModelProperty("测试任务进度")
    private Double test;

    @ApiModelProperty("测试任务开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date testBeginTime;

    @ApiModelProperty("测试任务结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date testEndTime;

    @ApiModelProperty("任务列表")
    private String taskList;

    @ApiModelProperty("指向待执行节点的指针[0、1、2]")
    private int pointer;

    @ApiModelProperty("试验方案ID")
    private String testSchemeId;

    @ApiModelProperty("是否选择场景")
    private Boolean taskScenario;

}
